"use strict";function _classCallCheck(e,n){if(!(e instanceof n))throw new TypeError("Cannot call a class as a function")}function _typeof(e){return e&&"undefined"!=typeof Symbol&&e.constructor===Symbol?"symbol":typeof e}function throwErrors(e){if(e.status>=200&&e.status<300)return e;var n=new Error(e.statusText);throw n.response=e,n}function decorateTo(e){return function(n){return new e(n)}}function mapTo(e){return function(n){return n.map(function(n){return new e(n)})}}function ParseJSON(e){return e.json()}var _slicedToArray=function(){function e(e,n){var r=[],t=!0,o=!1,i=void 0;try{for(var a,c=e[Symbol.iterator]();!(t=(a=c.next()).done)&&(r.push(a.value),!n||r.length!==n);t=!0);}catch(u){o=!0,i=u}finally{try{!t&&c["return"]&&c["return"]()}finally{if(o)throw i}}return r}return function(n,r){if(Array.isArray(n))return n;if(Symbol.iterator in Object(n))return e(n,r);throw new TypeError("Invalid attempt to destructure non-iterable instance")}}(),_createClass=function(){function e(e,n){for(var r=0;r<n.length;r++){var t=n[r];t.enumerable=t.enumerable||!1,t.configurable=!0,"value"in t&&(t.writable=!0),Object.defineProperty(e,t.key,t)}}return function(n,r,t){return r&&e(n.prototype,r),t&&e(n,t),n}}();Object.defineProperty(exports,"__esModule",{value:!0});var Errors={paramsShouldBeObject:new TypeError("Params should be an object or undefined."),endpointShouldBeObject:new TypeError("Endpoint is required and should be a string."),invalidRegex:new TypeError("Can't provide endpoint. Invalid regex."),invalidEndpointNode:new TypeError("Endpoint node (leaf) should be a string or an array with a string and an object"),traversingApiObject:new TypeError("Error when traversing api object. Expected object."),apiPrototypeShouldBeObject:new TypeError("Api prototype should be an object"),configShouldBeObject:new TypeError("Provided config should be an object"),prefixShouldBeString:new TypeError("Provided prefix should be a string"),fetchReferenceShouldBeFunction:new TypeError("Fetch reference should be a function"),fetchConfigShouldBeObject:new TypeError("Fetch config should be an object"),thenChainShouldBeArray:new TypeError("Then functions chain should be an array of functions"),cantFindFetch:new ReferenceError("Can't find fetch function. Please provide fetch polyfill"),cantFindObjectAssign:new ReferenceError("Can't find Object.assign function. Please provide Object.assign polyfill")},Util={isObject:function(e){return"object"===("undefined"==typeof e?"undefined":_typeof(e))&&!(e instanceof Array)&&null!==e},isString:function(e){return"string"==typeof e},isArray:function(e){return e instanceof Array},isRegex:function(e){return e instanceof RegExp},isFunction:function(e){return"function"==typeof e}},DefaultConfig={endpointRegex:/(?:\:)([a-zA-Z]([a-zA-Z0-9]|-|_)*)/g,endpointPrefix:"",fetchReference:void 0,fetchConfig:{},thenChain:[]},Api=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"parse",value:function(n){var r=arguments.length<=1||void 0===arguments[1]?{}:arguments[1];if(!Object.assign)throw Errors.cantFindObjectAssign;var t=Object.assign({},DefaultConfig,r);if(!Util.isObject(r))throw Errors.configShouldBeObject;if(!Util.isObject(n))throw Errors.modelShouldBeObject;if(!r.fetchReference&&!window.fetch)throw Errors.cantFindFetch;if(t.fetchReference&&!Util.isFunction(t.fetchReference))throw Errors.fetchReferenceShouldBeFunction;if(!Util.isRegex(t.endpointRegex))throw Errors.invalidRegex;if(!Util.isString(t.endpointPrefix))throw Errors.prefixShouldBeString;if(!Util.isObject(t.fetchConfig))throw Errors.fetchConfigShouldBeObject;if(!Util.isArray(t.thenChain))throw Errors.thenChainShouldBeArray;return e.__parseModel(n,{},t)}},{key:"__parseModel",value:function(n,r,t){if(!Util.isObject(n))throw Errors.traversingApiObject;for(var o in n)if(Util.isObject(n[o]))e.__parseModel(n[o],r[o]={},t);else{var i=e.__getEndpointWithFetchConfig(n[o]),a=_slicedToArray(i,2),c=a[0],u=a[1],f=e.__getRequestTypeByMethodName(o),s=e.__prefixEndpoint(t.endpointPrefix,c),l=Object.assign({method:f},t.fetchConfig,u),d=t.fetchReference||fetch;r[o]=e.__provideFunction({endpoint:s,fetchConfig:l,fetchReference:d,endpointRegex:t.endpointRegex,thenFunctionsChain:t.thenChain})}return r}},{key:"__provideFunction",value:function(n){var r=n.endpoint,t=n.fetchConfig,o=n.fetchReference,i=n.endpointRegex,a=n.thenFunctionsChain;return function(n,c){if(!Util.isObject(n)&&void 0!==n)throw Errors.paramsShouldBeObject;if(!Util.isObject(c)&&void 0!==c)throw Errors.fetchConfigShouldBeObject;var u=e.__parameterizeEndpoint(r,n,i),f=Object.assign(t,c),s=o(u,f);return e.__runChainOfThenFunctionsOnPromise(s,a)}}},{key:"__runChainOfThenFunctionsOnPromise",value:function(e,n){return n.reduce(function(e,n){return e.then(n)},e)}},{key:"__getEndpointWithFetchConfig",value:function(e){if(!(Util.isString(e)||Util.isArray(e)&&Util.isString(e[0])))throw Errors.invalidEndpointNode;return Util.isArray(e)?e:[e,{}]}},{key:"__prefixEndpoint",value:function(){var e=arguments.length<=0||void 0===arguments[0]?"":arguments[0],n=arguments[1];return""+e+n}},{key:"__parameterizeEndpoint",value:function(e,n,r){return e.replace(r,function(e,r){return n?n[r]||"":""})}},{key:"__getRequestTypeByMethodName",value:function(e){var n=-1!=["DELETE","GET","HEAD","OPTIONS","POST","PUT","PATCH"].indexOf(e.toUpperCase());return n?e.toUpperCase():"GET"}}]),e}(),index={parse:Api.parse,helpers:{parseJSON:ParseJSON,mapTo:mapTo,decorateTo:decorateTo,throwErrors:throwErrors}};exports["default"]=index,module.exports=exports["default"];